unit MPFilterContacts;

interface

implementation
uses
  SysUtils,
  FastStrings,
  MPPlugin,
  MessengerAPI_TLB;


procedure FilterContacts(var ASource: String; const AInfo: TMPFilterInfo);
var
  ifMessenger:  IMessenger;
  ifWindow:     IMessengerConversationWnd;
  ifContacts:   IMessengerContacts;
  ifContact:    IMessengerContact;
  sMyName:      String;
  sMyEmail:     String;
  sNames:       String;
  sEmails:      String;
  iContact:     Integer;

begin
  sMyName   := '';
  sMyEmail  := '';
  sNames    := '';
  sEmails   := '';

  if (Assigned(AInfo.Messenger)) and
     (Supports(AInfo.Messenger, IMessenger, ifMessenger)) then begin
    // Get local information
    sMyName   := ifMessenger.MyFriendlyName;
    sMyEmail  := ifMessenger.MySigninName;
  end;

  if (Assigned(AInfo.Conversation)) and
     (Supports(AInfo.Conversation, IMessengerConversationWnd, ifWindow)) then begin
    // Get contact information
    ifContacts  := IMessengerContacts(ifWindow.Contacts);
    for iContact  := 0 to ifContacts.Count - 1 do begin
      ifContact := IMessengerContact(ifContacts.Item(iContact));

      if iContact > 0 then begin
        sNames  := sNames + ', ';
        sEmails := sEmails + ', ';
      end;

      sNames  := sNames + ifContact.FriendlyName;
      sEmails := sEmails + ifContact.SigninName;
    end;
  end;

  ASource := FastReplace(ASource, '(!NP)', sMyName, True);
  ASource := FastReplace(ASource, '(!MP)', sMyEmail, True);
  ASource := FastReplace(ASource, '(!N)', sNames, True);
  ASource := FastReplace(ASource, '(!M)', sEmails, True);
end;


initialization
  RegisterFilter(FilterContacts);

end.
