program InstallPlugin;

uses
  Windows,
  Messages,
  SysUtils,
  Registry;

var
  hPluginChange:        Cardinal;
  sFile:                String;
  regPlus:              TRegistry;
  sPath:                String;

begin
  if ParamCount() < 1 then begin
    MessageBox(0, 'No file specified.', 'Error', MB_OK or MB_ICONERROR);
    exit;
  end;

  sFile := ParamStr(1);
  if not FileExists(sFile) then begin
    MessageBox(0, 'File does not exist.', 'Error', MB_OK or MB_ICONERROR);
    exit;
  end;

  regPlus := TRegistry.Create();
  try
    regPlus.RootKey := HKEY_LOCAL_MACHINE;
    if regPlus.OpenKey('\Software\Patchou\MsgPlus2', False) then begin
      sPath := regPlus.ReadString('PluginDir');
      regPlus.CloseKey();
    end else begin
      MessageBox(0, 'Plus! not correctly installed.', 'Error',
                 MB_OK or MB_ICONERROR);
      exit;
    end;
  finally
    FreeAndNil(regPlus);
  end;

  hPluginChange := RegisterWindowMessage('MessengerPlus_PluginChange');
  PostMessage(HWND_BROADCAST, hPluginChange, 0, 0);

  Sleep(1000);
  sPath := IncludeTrailingPathDelimiter(sPath) + ExtractFileName(sFile);
  CopyFile(PChar(sFile), PChar(sPath), False);
end.
